///+------------------------------------------------------------------

//|                                                 RSIFilter_v1.mq4 

//|                                  Copyright  2006, Forex-TSD.com 

//|                         Written by IgorAD,igorad2003@yahoo.co.uk 
   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory 
                                      
//+------------------------------------------------------------------

#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_separate_window
#property indicator_minimum -2
#property indicator_maximum 2
#property indicator_buffers 2
#property indicator_color1 DeepSkyBlue
#property indicator_color2 Red

//---- input parameters
extern int PeriodRSI           =14;
extern ENUM_APPLIED_PRICE Price=PRICE_CLOSE;
//---- indicator buffers
double UpBuffer[];
double DnBuffer[];
double trend[];
//+------------------------------------------------------------------

//| Custom indicator initialization function                         

//+------------------------------------------------------------------

int init()
{
   IndicatorBuffers(3);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(0,UpBuffer);
   SetIndexBuffer(1,DnBuffer);
   SetIndexBuffer(2,trend);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   SetIndexLabel(0,"UpTrend");
   SetIndexLabel(1,"DownTrend");
   IndicatorShortName("RSI Filter("+PeriodRSI+")  (Down trade only when down bars are orange)");
   return(0);
  }

//+------------------------------------------------------------------

//| RSIFilter_v1                                                     

//+------------------------------------------------------------------

double wrkBuffer[][13];
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(wrkBuffer,0) != Bars) ArrayResize(wrkBuffer,Bars);

   
   double Kg = (3.0)/(2.0+PeriodRSI); 
   double Hg = 1.0-Kg;
   for(i=limit, r=Bars-i-1; i>=0; i--, r++)
   {
      wrkBuffer[r][12] = iMA(NULL,0,1,0,MODE_SMA,Price,i);

         if (i==(Bars-1)) { for (int c=0; c<12; c++) wrkBuffer[r][c] = 0; continue; }  

      //
      //
      //
      //
      //
      
      double mom = wrkBuffer[r][12]-wrkBuffer[r-1][12];
      double moa = MathAbs(mom);
      for (int k=0; k<3; k++)
      {
         int kk = k*2;
            wrkBuffer[r][kk+0] = Kg*mom                + Hg*wrkBuffer[r-1][kk+0];
            wrkBuffer[r][kk+1] = Kg*wrkBuffer[r][kk+0] + Hg*wrkBuffer[r-1][kk+1]; mom = 1.5*wrkBuffer[r][kk+0] - 0.5 * wrkBuffer[r][kk+1];
            wrkBuffer[r][kk+6] = Kg*moa                + Hg*wrkBuffer[r-1][kk+6];
            wrkBuffer[r][kk+7] = Kg*wrkBuffer[r][kk+6] + Hg*wrkBuffer[r-1][kk+7]; moa = 1.5*wrkBuffer[r][kk+6] - 0.5 * wrkBuffer[r][kk+7];
      }
      if (moa != 0)
           double RSI0 = MathMax(MathMin((mom/moa+1.0)*50.0,100.00),0.00); 
      else        RSI0 = 50;
      trend[i] = trend[i+1];
	   if (RSI0>70)  trend[i]= 1; 
	   if (RSI0<30)  trend[i]=-1;
	   if (trend[i]>0) 
	   {
	      if (RSI0 > 40) UpBuffer[i]=1.0; else UpBuffer[i] = EMPTY_VALUE;
      	               DnBuffer[i]=0;
	  }
	  if (trend[i]<0) 
	  {
	      if (RSI0 < 60) DnBuffer[i]=-1.0; else DnBuffer[i] = EMPTY_VALUE;
	                     UpBuffer[i]=0;
	  }
	}
	return(0);	
}